// https://edith.xiaohongshu.com/api/sns/web/unread_count

import { QueryRouterServer } from '@kevisual/router';
import { redis } from '@/modules/redis.ts';
import { Queue } from 'bullmq';
import { app as xhsApp } from '@kevisual/xhs/index';
import { nanoid } from 'nanoid';
export const XHS_GET_UNREAD = 'unread_count';
export const XHS_QUEUE_NAME = 'XHS_QUEUE';

export const taskApp = new QueryRouterServer();
export { xhsApp };
export const queue = new Queue(XHS_QUEUE_NAME, {
  connection: redis,
});

export const addUnreadTask = async (nextTime = 0) => {
  const id = 'unread';
  const job = await queue.add(
    'unread',
    {
      path: 'task',
      key: 'getUnread',
    },
    {
      delay: nextTime,
      removeOnComplete: true,
      removeOnFail: {
        age: 24 * 3600, // keep up to 24 hours
      },
      jobId: id,
    },
  );
  return {
    id,
    job,
  };
};
